Description

Trying to retrieve opearating system properties via API an empty set of results is returned when using "?search" method in the url.

Attached the result of calling the following urls:

https://&lt;foreman_server&gt;/api/v2/operatingsystems

https://&lt;foreman_server&gt;/api/v2/operatingsystems?search=CentOS

History

#1 - 03/24/2014 04:15 PM - Dominic Cleal

Try using a "attribute = value" style of searching instead of relying on free text search.  The same search rules as in the UI (which has a useful

auto-complete) apply here, so "name = CentOS" will return all CentOS operating systems.

#2 - 03/25/2014 07:48 AM - Xavier Naveira

- File operatingsystemsbyname.htm added

- File operatingsystemsbyfullname.htm added

Hi Dominic,

Thank you for your answer.

Unfortunately using "attribute=value" doesn't seem to work either.

When searching using the following urls I get the whole list of operating systems in my Foreman installation (see results attached)

https://&amp;lt;foreman_server&amp;gt;/api/v2/operatingsystems?name=CentOS

 https://&amp;lt;foreman_server&amp;gt;/api/v2/operatingsystems?fullname=CentOS 6.3

 Another way to search for objects that I'm using successfully when looking for hosts is to use their name in the url like this:

https://&amp;lt;foreman_server&amp;gt;/api/v2/hosts/&amp;lt;name_of_the_server&gt;

 So I thought to give it a try and do the same and test:

https://&amp;lt;foreman_server&amp;gt;/api/v2/operatingsystems/CentOS 6.3

 But it seems to be a problem with the parsing because the call aboive throws back:

{

"error": {

        "message": "Resource operatingsystem not found by id 'CentOS 6'" 

    }

 }

#3 - 03/25/2014 08:04 AM - Dominic Cleal
https://&lt;foreman_server&gt;/api/v2/operatingsystems
https://&lt;foreman_server&gt;/api/v2/operatingsystems?search=CentOS


The "attribute=value" is still passed within the "search" parameter, sorry that wasn't clear.  For example:

https://foreman_server/api/v2/operatingsystems?search=fullname=CentOS 6.3

 Have a look at the GUI for a better idea, you'll be able to search for something and reuse the same search string against the API.

The parse issue has been fixed in #4201 for Foreman 1.5.0.

#4 - 03/25/2014 08:41 AM - Xavier Naveira

Ok, so searching like this:

https://foreman_server/api/v2/operatingsystems?search=fullname=CentOS 6.3

 Gives back:

{

 
"error": {

         "message": "Field 'fullname' not recognized for searching!",

         "class": "ScopedSearch::QueryNotSupported" 

     }

 
}

 But I see your point and the parsing issue solved is all that I need.

Thank you for your help! You may now close this issue.

#5 - 03/25/2014 09:11 AM - Dominic Cleal

- Status changed from New to Resolved

Oh sorry, I copied your example without reading and checking it.  It looks like we don't have a field at the moment for the "fullname", since that area

(the concatenated name) is a bit complex and messy.  It may be better to search for a specific name, major and minor.  Anyway, glad that helped a

bit, closing.
